program showpal;
{$G+}
uses dos;

function readkey:char; assembler;
asm
        xor     ax,ax
        int     16h
end;

procedure setmode(mode:word); assembler;
asm
        mov     ax,mode
        int     10h
end;

procedure drawbars; assembler;
asm
        mov     es,sega000
        xor     di,di
        mov     dx,200
@@lop:  mov     cx,128
        mov     ax,1 shl 8
@@ilop: stosw
        add     ax,514
        dec     cx
        jnz     @@ilop
        add     di,320-256
        dec     dx
        jnz     @@lop
end;

procedure makepal(pal:pointer); assembler;
asm
        push    ds
        lds     si,pal
	mov     dx,$3c8
        mov     cx,768
        xor     al,al

        out     dx,al
        inc     dx
        rep     outsb
        pop     ds
end;

procedure loadpal(const s:string);
var f:file;
    pal:pointer;
begin
 getmem(pal,768);
 assign(f,s);
 reset(f,1);
 blockread(f,pal^,768);
 makepal(pal);
 freemem(pal,768)
end;

begin
 if paramcount<>1 then
  begin
   writeln('Usage:  Showpal <filename>');
   halt;
  end;
 if fsearch(paramstr(1),'')='' then
  begin
   writeln('File not found: ',paramstr(1));
   halt
  end;
 setmode($13);
 drawbars;
 loadpal(paramstr(1));
 readkey;
 setmode(3)
end.